#pragma once

#include <iostream>
#include <string>  
#include "json/json-forwards.h"
#include "../../sdk/restc.h"
#pragma comment(lib,"../../sdk/restc.lib")

#define RESTCMD_BUFSZ	1024

enum http_status_code
{
	HTTP_OK = 200,
	HTTP_Created = 201,
	HTTP_BadRequest = 400,
	HTTP_NotFound = 404,
	HTTP_InternalServerError = 500,
	HTTP_BadGateway = 502,
};

/** RestCmd
  * restc.dllķװ豸HTTP,JSONн
  *
  *	гԱڷrestcʱΪ׳std::runtime_error쳣
  *	JSON׳Json::Exception쳣
**/
class RestCmd
{
public:

	/* 캯ֻԴӻδ */
	RestCmd(const std::string & ip, unsigned short port);
	~RestCmd();

	/** 豸,ݲμֲ **/
	static void setAuthorization(const std::string & user, const std::string & passwd);
	/** ʱԺΪλĬӳʱΪ30000 **/
	void setTimeout(int seconds);

	/* HTTP GET  */
	void restGet(const std::string & url_path, Json::Value & reply, int & statusCode);
	void restGetBin(const std::string & url_path, char * buf);
	/* HTTP PUT , 豸Ϣǿѡ */
	void restPut(const std::string & url_path, const Json::Value & request, Json::Value *preply, int & statusCode);
	/* HTTP POST 豸Ϣǿѡ */
	void restPost(const std::string & url_path, const Json::Value & request, Json::Value *preply, int & statusCode);
	/* HTTP DELETE  */
	void restDel(const std::string & url_path, int & statusCode);

private:
	/** POST  PUT  **/
	void _restPut(const std::string & url_path, const Json::Value & request, Json::Value *preply, int & statusCode
		, int(*put_func)(RestConn, const char *, RestHeaders, char *, size_t, size_t *));

	RestConn _rest_conn;
	char * _rest_buf;
	Json::CharReader* _reader;
};
